'******************************************************
'* Beispiel zum Auswerten einer Schieberegister-      *
'* eingangserweiterung (z.B. auf Basis des 74HC166):  *
'* SR-IN-HS und SR-AC-IN-HS                           *
'* in CC1-Basic, ohne Assembler                       *
'* http://cctools.hs-control.de                       *
'* Release: 09.03.04                                  *
'******************************************************

'Portdefinition - kann beliebig angepasst werden
define DS Port[1] ' Dateneingang
define SH Port[2] ' Shift-Clock
define PL Port[3] ' Parallel-Load

'Variabeldefninition fr Portzustnde
' kann beliebig angepasst werden
' Die Bit-Variablen mssen SRIN berlagern !
define SRIN byte[1] ' Variable fr eingelesenen Byteport
define SR_P0 bit[1] ' Eingang L4 (SR-AC-IN) bzw. Eingang 0 (SR-IN)
define SR_P1 bit[2] ' Eingang L3 (SR-AC-IN) bzw. Eingang 1 (SR-IN)
define SR_P2 bit[3] ' Eingang L2 (SR-AC-IN) bzw. Eingang 2 (SR-IN)
define SR_P3 bit[4] ' Eingang L1 (SR-AC-IN) bzw. Eingang 3 (SR-IN)
define SR_P4 bit[5] ' immer 0 bei SR-AC-IN bzw. Eingang 4 (SR-IN)
define SR_P5 bit[6] ' immer 0 bei SR-AC-IN bzw. Eingang 5 (SR-IN) (Ltpad)
define SR_P6 bit[7] ' immer 0 bei SR-AC-IN bzw. Eingang 6 (SR-IN) (Ltpad)
define SR_P7 bit[8] ' immer 0 bei SR-AC-IN bzw. Eingang 7 (SR-IN) (Ltpad)

define i byte [2] 'Indexvariable fr for-Schleife
define device byte [3] 'Variable zur bergabe der Bausteinnr. (1.Baustein=0, 2.=1 usw.)


goto beispiel1 'Ausgabe der Portzustnde bei einer SR-Erweiterung
'goto beispiel2 'Ausgabe der Portzustnde bei zwei SR-Erweiterungen


#beispiel1
 put 12
 print "Beispiel1"
 print "P0/L4","P1/L3","P2/L2","P3/L1","P4","P5","P6","P7"
 device=0
 #beispiel1_loop
  gosub getDevStates
  print abs(SR_P0),abs(SR_P1),abs(SR_P2),abs(SR_P3),abs(SR_P4),abs(SR_P5),abs(SR_P6),abs(SR_P7);
  put 13
  pause 10
goto beispiel1_loop


#beispiel2
 put 12
 print "Beispiel2"
 print "P0/L4","P1/L3","P2/L2","P3/L1","P4","P5","P6","P7"
 device=0
 #beispiel2_loop
  device=0
  gosub getDevStates
  print abs(SR_P0),abs(SR_P1),abs(SR_P2),abs(SR_P3),abs(SR_P4),abs(SR_P5),abs(SR_P6),abs(SR_P7)
  device=1
  gosub getDevStates
  print abs(SR_P0),abs(SR_P1),abs(SR_P2),abs(SR_P3),abs(SR_P4),abs(SR_P5),abs(SR_P6),abs(SR_P7)
  put 27 : print "[2A"; ' ANSI-code: "ESC[nA" - Move Cursor Up
  pause 10
goto beispiel2_loop


#getDevStates
 SH=Off
 PL=Off
 pulse SH
 PL=On
 SRIN=0
 if device=0 then goto onedev
   for i=1 to device*8
    pulse SH
   next i
 #onedev
 for i=0 to 7
  SRIN=SRIN or ((DS and &h80) shr i)
  pulse SH
 next i
return
